* Version 1.0
LPARAMETERS lcFileName,llNoTables
* lcFileName		name of the document
					* nom de document
					* numele documentului
DECLARE Sleep IN WIN32API INTEGER 
#DEFINE ERRLANG "En"
#IF ERRLANG = "Ro"
	#DEFINE ERRMESS0 "Eroare"
	#DEFINE ERRMESS1 "Nimic de importat"
#ELIF ERRLANG = "Fr"
	#DEFINE ERRMESS0 "Erreur"
	#DEFINE ERRMESS1 "Rien a ajouter"
#ELIF ERRLANG = "Nl" && Koen Piller
	#DEFINE ERRMESS0 "Fout"
	#DEFINE ERRMESS1 "Niets te importeren"
#ELSE
	#DEFINE ERRMESS0 "Error"
	#DEFINE ERRMESS1 "Nothing to append"
#ENDIF

LOCAL lcDir,lSetTalk,lcCur,lnFile,laFile[1],lni,loXDOM 

IF PCOUNT() < 1 
	MESSAGEBOX(ERRMESS1,16,ERRMESS0)
	RETURN
ELSE
	IF VARTYPE(m.lcFileName) $ "CV"
		IF INLIST(LOWER(JUSTEXT(m.lcFileName)),"ods","odt","odp")
			IF ADIR(laFile, m.lcFileName) = 0
				MESSAGEBOX(ERRMESS1,16,ERRMESS0)
				RETURN
			ENDIF
		ELSE
			lnFile = 0
			FOR lni = 1 TO ADIR(laFile, FORCEEXT(m.lcFileName,'*'))
				IF INLIST(LOWER(JUSTEXT(m.laFile[m.lni,1])),"ods","odt","odp")
					lnFile = m.lni
					m.lcFileName = m.laFile[m.lni,1]
					EXIT
				ENDIF
			NEXT
			IF m.lnFile = 0
				MESSAGEBOX(ERRMESS1,16,ERRMESS0)
				RETURN
			ENDIF
		ENDIF
	ELSE
		MESSAGEBOX(ERRMESS1,16,ERRMESS0)
		RETURN
	ENDIF
ENDIF

lSetTalk = SET("Talk")
SET TALK OFF 

lcDir = extract(m.lcFileName)

lcCur = gen_text(ADDBS(m.lcDir) + "content.xml",@loXDOM,m.lcFileName,m.llNoTables)

cleanup(m.lcDir,@loXDOM)
IF USED(m.lcCur)
	USE IN (m.lcCur)
ENDIF
SET TALK &lSetTalk
RETURN m.lcCur

*********************
* Extract xml files *
*********************
FUNCTION extract
	LPARAMETERS lcFileName
	LOCAL lcDir,lcZip,oShell,ofile,loErr as Exception,lcSetSaf,lni,lnFF
	lcDir = ADDBS(SYS(2023)) + SYS(2015)
	lcZip = FORCEEXT(m.lcDir,'.zip')
	COPY FILE (m.lcFileName) TO (m.lcZip)
	MD (m.lcDir)
	oShell = CREATEOBJECT("shell.application")
	TRY
		FOR lni = 0 TO m.oShell.NameSpace(m.lcZip).items.count - 1
			ofile = m.oShell.NameSpace(m.lcZip).items.item(m.lni)
			IF m.ofile.name == 'content.xml'
				oShell.NameSpace( m.lcDir).copyhere( m.ofile)
				lnFF = FOPEN(ADDBS(lcDir) + m.ofile.name)
				DO WHILE m.lnFF < 0
					sleep(50)
					lnFF = FOPEN(m.ofile.name)
				ENDDO
				FCLOSE(m.lnFF)
			ENDIF
		ENDFOR
	CATCH TO loErr
	ENDTRY
RETURN lcDir
	

*****************
* Read document *
*****************
FUNCTION gen_text
	LPARAMETERS lcStr,loXDOM,lcFileName,llNoTables
	LOCAL lni, loPars, lnNoOfPars, lnTxtFile 
	loXDOM = CREATEOBJECT('MSXML2.DOMDocument')	
	loXDOM.Load(m.lcStr)
	loPars = loXDOM.getElementsByTagName("text:p")
	lnNoOfPars = loPars.Length
	
	lnTxtFile = FCREATE(FORCEEXT(m.lcFileName,'txt'))
	IF m.lnTxtFile < 0 
		MESSAGEBOX(ERRMESS0,16,ERRMESS0)
		RETURN ''
	ENDIF
	*FWRITE(m.lnTxtFile,CHR(0xFE)+CHR(0xFF))
	IF m.llNoTables
		FOR lni = 0 TO m.lnNoOfPars - 1
			IF loPars.Item(m.lni).parentNode.nodeName == "office:text"
				FPUTS(m.lnTxtFile,loPars.Item(m.lni).nodeTypedValue)
			ENDIF
		NEXT
	ELSE
		FOR lni = 0 TO m.lnNoOfPars - 1
			FPUTS(m.lnTxtFile,loPars.Item(m.lni).nodeTypedValue)
		NEXT
	ENDIF
	FCLOSE(m.lnTxtFile)
	
RETURN FORCEEXT(m.lcFileName,'txt')


**********************
* Special characters *
**********************
FUNCTION htmspec
	LPARAMETERS cStr
	LOCAL lni,lcStrF,lcChar,lnChar
	lcStrF = m.cStr
	IF AT('&gt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&gt;','>')
	ENDIF
	IF AT('&lt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&lt;','<')
	ENDIF
	IF AT('&quot;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&quot;','"')
	ENDIF
	IF AT("&apos;",m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&apos;',"'")
	ENDIF
	IF AT([&#],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#]+STR(m.lnChar,3)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT([&#x],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#x]+RIGHT(TRANSFORM(m.lnChar,"@0"),2)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT('&amp;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&amp;',CHR(38))
	ENDIF

    * suggested by Koen Piller
	lcStrF = STRCONV(m.lcStrF,11)
	RETURN m.lcStrF
ENDFUNC

*****************
* Cleanup
******************
FUNCTION cleanup
	LPARAMETERS lcDir,loXDOM
	LOCAL lcZip,lcSetSaf
	RELEASE loXDOM
	lcZip = FORCEEXT(m.lcDir,'zip')
	lcSetSaf = SET("Safety")
	SET SAFETY OFF
	TRY 
		ERASE (ADDBS(m.lcDir)+'*.*')
		RD (m.lcDir)
	CATCH TO m.loErr
	ENDTRY

	ERASE (m.lcZip)
	SET SAFETY &lcSetSaf
RETURN .T.

